// This file automagically generated, do not edit
#ifndef JIT_CODEGEN_OP_DOUBLE_HPP
#define JIT_CODEGEN_OP_DOUBLE_HPP 1
#include "math.codegen.h"
#include "jit.codegen.vec.hpp"
#include "jit.codegen.op.hpp"

double abs(const double v) {
	return abs_double(v);
}

Vec2<double> abs(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = abs_double(v.x);
	rv.y = abs_double(v.y);

	return rv;
}

Vec3<double> abs(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = abs_double(v.x);
	rv.y = abs_double(v.y);
	rv.z = abs_double(v.z);

	return rv;
}

Vec4<double> abs(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = abs_double(v.x);
	rv.y = abs_double(v.y);
	rv.z = abs_double(v.z);
	rv.w = abs_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> abs(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = abs_double(v.v[i]);
	}
	return rv;
}

double acos(const double v) {
	return acos_double(v);
}

Vec2<double> acos(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = acos_double(v.x);
	rv.y = acos_double(v.y);

	return rv;
}

Vec3<double> acos(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = acos_double(v.x);
	rv.y = acos_double(v.y);
	rv.z = acos_double(v.z);

	return rv;
}

Vec4<double> acos(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = acos_double(v.x);
	rv.y = acos_double(v.y);
	rv.z = acos_double(v.z);
	rv.w = acos_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> acos(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = acos_double(v.v[i]);
	}
	return rv;
}

double acosh(const double v) {
	return acosh_double(v);
}

Vec2<double> acosh(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = acosh_double(v.x);
	rv.y = acosh_double(v.y);

	return rv;
}

Vec3<double> acosh(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = acosh_double(v.x);
	rv.y = acosh_double(v.y);
	rv.z = acosh_double(v.z);

	return rv;
}

Vec4<double> acosh(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = acosh_double(v.x);
	rv.y = acosh_double(v.y);
	rv.z = acosh_double(v.z);
	rv.w = acosh_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> acosh(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = acosh_double(v.v[i]);
	}
	return rv;
}

double asin(const double v) {
	return asin_double(v);
}

Vec2<double> asin(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = asin_double(v.x);
	rv.y = asin_double(v.y);

	return rv;
}

Vec3<double> asin(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = asin_double(v.x);
	rv.y = asin_double(v.y);
	rv.z = asin_double(v.z);

	return rv;
}

Vec4<double> asin(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = asin_double(v.x);
	rv.y = asin_double(v.y);
	rv.z = asin_double(v.z);
	rv.w = asin_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> asin(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = asin_double(v.v[i]);
	}
	return rv;
}

double asinh(const double v) {
	return asinh_double(v);
}

Vec2<double> asinh(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = asinh_double(v.x);
	rv.y = asinh_double(v.y);

	return rv;
}

Vec3<double> asinh(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = asinh_double(v.x);
	rv.y = asinh_double(v.y);
	rv.z = asinh_double(v.z);

	return rv;
}

Vec4<double> asinh(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = asinh_double(v.x);
	rv.y = asinh_double(v.y);
	rv.z = asinh_double(v.z);
	rv.w = asinh_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> asinh(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = asinh_double(v.v[i]);
	}
	return rv;
}

double atan(const double v) {
	return atan_double(v);
}

Vec2<double> atan(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = atan_double(v.x);
	rv.y = atan_double(v.y);

	return rv;
}

Vec3<double> atan(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = atan_double(v.x);
	rv.y = atan_double(v.y);
	rv.z = atan_double(v.z);

	return rv;
}

Vec4<double> atan(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = atan_double(v.x);
	rv.y = atan_double(v.y);
	rv.z = atan_double(v.z);
	rv.w = atan_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> atan(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = atan_double(v.v[i]);
	}
	return rv;
}

double atanh(const double v) {
	return atanh_double(v);
}

Vec2<double> atanh(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = atanh_double(v.x);
	rv.y = atanh_double(v.y);

	return rv;
}

Vec3<double> atanh(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = atanh_double(v.x);
	rv.y = atanh_double(v.y);
	rv.z = atanh_double(v.z);

	return rv;
}

Vec4<double> atanh(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = atanh_double(v.x);
	rv.y = atanh_double(v.y);
	rv.z = atanh_double(v.z);
	rv.w = atanh_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> atanh(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = atanh_double(v.v[i]);
	}
	return rv;
}

double ceil(const double v) {
	return ceil_double(v);
}

Vec2<double> ceil(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = ceil_double(v.x);
	rv.y = ceil_double(v.y);

	return rv;
}

Vec3<double> ceil(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = ceil_double(v.x);
	rv.y = ceil_double(v.y);
	rv.z = ceil_double(v.z);

	return rv;
}

Vec4<double> ceil(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = ceil_double(v.x);
	rv.y = ceil_double(v.y);
	rv.z = ceil_double(v.z);
	rv.w = ceil_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> ceil(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = ceil_double(v.v[i]);
	}
	return rv;
}

double cos(const double v) {
	return cos_double(v);
}

Vec2<double> cos(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = cos_double(v.x);
	rv.y = cos_double(v.y);

	return rv;
}

Vec3<double> cos(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = cos_double(v.x);
	rv.y = cos_double(v.y);
	rv.z = cos_double(v.z);

	return rv;
}

Vec4<double> cos(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = cos_double(v.x);
	rv.y = cos_double(v.y);
	rv.z = cos_double(v.z);
	rv.w = cos_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> cos(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = cos_double(v.v[i]);
	}
	return rv;
}

double cosh(const double v) {
	return cosh_double(v);
}

Vec2<double> cosh(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = cosh_double(v.x);
	rv.y = cosh_double(v.y);

	return rv;
}

Vec3<double> cosh(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = cosh_double(v.x);
	rv.y = cosh_double(v.y);
	rv.z = cosh_double(v.z);

	return rv;
}

Vec4<double> cosh(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = cosh_double(v.x);
	rv.y = cosh_double(v.y);
	rv.z = cosh_double(v.z);
	rv.w = cosh_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> cosh(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = cosh_double(v.v[i]);
	}
	return rv;
}

double exp(const double v) {
	return exp_double(v);
}

Vec2<double> exp(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = exp_double(v.x);
	rv.y = exp_double(v.y);

	return rv;
}

Vec3<double> exp(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = exp_double(v.x);
	rv.y = exp_double(v.y);
	rv.z = exp_double(v.z);

	return rv;
}

Vec4<double> exp(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = exp_double(v.x);
	rv.y = exp_double(v.y);
	rv.z = exp_double(v.z);
	rv.w = exp_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> exp(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = exp_double(v.v[i]);
	}
	return rv;
}

double exp2(const double v) {
	return exp2_double(v);
}

Vec2<double> exp2(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = exp2_double(v.x);
	rv.y = exp2_double(v.y);

	return rv;
}

Vec3<double> exp2(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = exp2_double(v.x);
	rv.y = exp2_double(v.y);
	rv.z = exp2_double(v.z);

	return rv;
}

Vec4<double> exp2(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = exp2_double(v.x);
	rv.y = exp2_double(v.y);
	rv.z = exp2_double(v.z);
	rv.w = exp2_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> exp2(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = exp2_double(v.v[i]);
	}
	return rv;
}

double floor(const double v) {
	return floor_double(v);
}

Vec2<double> floor(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = floor_double(v.x);
	rv.y = floor_double(v.y);

	return rv;
}

Vec3<double> floor(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = floor_double(v.x);
	rv.y = floor_double(v.y);
	rv.z = floor_double(v.z);

	return rv;
}

Vec4<double> floor(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = floor_double(v.x);
	rv.y = floor_double(v.y);
	rv.z = floor_double(v.z);
	rv.w = floor_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> floor(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = floor_double(v.v[i]);
	}
	return rv;
}

double fract(const double v) {
	return fract_double(v);
}

Vec2<double> fract(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = fract_double(v.x);
	rv.y = fract_double(v.y);

	return rv;
}

Vec3<double> fract(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = fract_double(v.x);
	rv.y = fract_double(v.y);
	rv.z = fract_double(v.z);

	return rv;
}

Vec4<double> fract(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = fract_double(v.x);
	rv.y = fract_double(v.y);
	rv.z = fract_double(v.z);
	rv.w = fract_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> fract(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = fract_double(v.v[i]);
	}
	return rv;
}

double log(const double v) {
	return log_double(v);
}

Vec2<double> log(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = log_double(v.x);
	rv.y = log_double(v.y);

	return rv;
}

Vec3<double> log(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = log_double(v.x);
	rv.y = log_double(v.y);
	rv.z = log_double(v.z);

	return rv;
}

Vec4<double> log(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = log_double(v.x);
	rv.y = log_double(v.y);
	rv.z = log_double(v.z);
	rv.w = log_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> log(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = log_double(v.v[i]);
	}
	return rv;
}

double log2(const double v) {
	return log2_double(v);
}

Vec2<double> log2(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = log2_double(v.x);
	rv.y = log2_double(v.y);

	return rv;
}

Vec3<double> log2(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = log2_double(v.x);
	rv.y = log2_double(v.y);
	rv.z = log2_double(v.z);

	return rv;
}

Vec4<double> log2(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = log2_double(v.x);
	rv.y = log2_double(v.y);
	rv.z = log2_double(v.z);
	rv.w = log2_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> log2(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = log2_double(v.v[i]);
	}
	return rv;
}

double log10(const double v) {
	return log10_double(v);
}

Vec2<double> log10(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = log10_double(v.x);
	rv.y = log10_double(v.y);

	return rv;
}

Vec3<double> log10(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = log10_double(v.x);
	rv.y = log10_double(v.y);
	rv.z = log10_double(v.z);

	return rv;
}

Vec4<double> log10(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = log10_double(v.x);
	rv.y = log10_double(v.y);
	rv.z = log10_double(v.z);
	rv.w = log10_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> log10(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = log10_double(v.v[i]);
	}
	return rv;
}

double lnot(const double v) {
	return lnot_double(v);
}

Vec2<double> lnot(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = lnot_double(v.x);
	rv.y = lnot_double(v.y);

	return rv;
}

Vec3<double> lnot(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = lnot_double(v.x);
	rv.y = lnot_double(v.y);
	rv.z = lnot_double(v.z);

	return rv;
}

Vec4<double> lnot(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = lnot_double(v.x);
	rv.y = lnot_double(v.y);
	rv.z = lnot_double(v.z);
	rv.w = lnot_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> lnot(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = lnot_double(v.v[i]);
	}
	return rv;
}

double round(const double v) {
	return round_double(v);
}

Vec2<double> round(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = round_double(v.x);
	rv.y = round_double(v.y);

	return rv;
}

Vec3<double> round(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = round_double(v.x);
	rv.y = round_double(v.y);
	rv.z = round_double(v.z);

	return rv;
}

Vec4<double> round(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = round_double(v.x);
	rv.y = round_double(v.y);
	rv.z = round_double(v.z);
	rv.w = round_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> round(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = round_double(v.v[i]);
	}
	return rv;
}

double sign(const double v) {
	return sign_double(v);
}

Vec2<double> sign(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = sign_double(v.x);
	rv.y = sign_double(v.y);

	return rv;
}

Vec3<double> sign(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = sign_double(v.x);
	rv.y = sign_double(v.y);
	rv.z = sign_double(v.z);

	return rv;
}

Vec4<double> sign(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = sign_double(v.x);
	rv.y = sign_double(v.y);
	rv.z = sign_double(v.z);
	rv.w = sign_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> sign(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = sign_double(v.v[i]);
	}
	return rv;
}

double sin(const double v) {
	return sin_double(v);
}

Vec2<double> sin(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = sin_double(v.x);
	rv.y = sin_double(v.y);

	return rv;
}

Vec3<double> sin(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = sin_double(v.x);
	rv.y = sin_double(v.y);
	rv.z = sin_double(v.z);

	return rv;
}

Vec4<double> sin(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = sin_double(v.x);
	rv.y = sin_double(v.y);
	rv.z = sin_double(v.z);
	rv.w = sin_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> sin(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = sin_double(v.v[i]);
	}
	return rv;
}

double sinh(const double v) {
	return sinh_double(v);
}

Vec2<double> sinh(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = sinh_double(v.x);
	rv.y = sinh_double(v.y);

	return rv;
}

Vec3<double> sinh(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = sinh_double(v.x);
	rv.y = sinh_double(v.y);
	rv.z = sinh_double(v.z);

	return rv;
}

Vec4<double> sinh(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = sinh_double(v.x);
	rv.y = sinh_double(v.y);
	rv.z = sinh_double(v.z);
	rv.w = sinh_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> sinh(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = sinh_double(v.v[i]);
	}
	return rv;
}

double sqrt(const double v) {
	return sqrt_double(v);
}

Vec2<double> sqrt(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = sqrt_double(v.x);
	rv.y = sqrt_double(v.y);

	return rv;
}

Vec3<double> sqrt(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = sqrt_double(v.x);
	rv.y = sqrt_double(v.y);
	rv.z = sqrt_double(v.z);

	return rv;
}

Vec4<double> sqrt(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = sqrt_double(v.x);
	rv.y = sqrt_double(v.y);
	rv.z = sqrt_double(v.z);
	rv.w = sqrt_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> sqrt(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = sqrt_double(v.v[i]);
	}
	return rv;
}

double tan(const double v) {
	return tan_double(v);
}

Vec2<double> tan(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = tan_double(v.x);
	rv.y = tan_double(v.y);

	return rv;
}

Vec3<double> tan(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = tan_double(v.x);
	rv.y = tan_double(v.y);
	rv.z = tan_double(v.z);

	return rv;
}

Vec4<double> tan(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = tan_double(v.x);
	rv.y = tan_double(v.y);
	rv.z = tan_double(v.z);
	rv.w = tan_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> tan(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = tan_double(v.v[i]);
	}
	return rv;
}

double tanh(const double v) {
	return tanh_double(v);
}

Vec2<double> tanh(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = tanh_double(v.x);
	rv.y = tanh_double(v.y);

	return rv;
}

Vec3<double> tanh(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = tanh_double(v.x);
	rv.y = tanh_double(v.y);
	rv.z = tanh_double(v.z);

	return rv;
}

Vec4<double> tanh(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = tanh_double(v.x);
	rv.y = tanh_double(v.y);
	rv.z = tanh_double(v.z);
	rv.w = tanh_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> tanh(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = tanh_double(v.v[i]);
	}
	return rv;
}

double trunc(const double v) {
	return trunc_double(v);
}

Vec2<double> trunc(const Vec2<double> &v) {
	Vec2<double> rv;
	rv.x = trunc_double(v.x);
	rv.y = trunc_double(v.y);

	return rv;
}

Vec3<double> trunc(const Vec3<double> &v) {
	Vec3<double> rv;
	rv.x = trunc_double(v.x);
	rv.y = trunc_double(v.y);
	rv.z = trunc_double(v.z);

	return rv;
}

Vec4<double> trunc(const Vec4<double> &v) {
	Vec4<double> rv;
	rv.x = trunc_double(v.x);
	rv.y = trunc_double(v.y);
	rv.z = trunc_double(v.z);
	rv.w = trunc_double(v.w);

	return rv;
}

template <unsigned N>
VecN<double, N> trunc(const VecN<double, N> &v) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = trunc_double(v.v[i]);
	}
	return rv;
}

double absdiff(const double v1, const double v2) {
	return absdiff_double(v1, v2);
}

Vec2<double> absdiff(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = absdiff_double(v1.x, v2.x);
	rv.y = absdiff_double(v1.y, v2.y);

	return rv;
}

Vec3<double> absdiff(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = absdiff_double(v1.x, v2.x);
	rv.y = absdiff_double(v1.y, v2.y);
	rv.z = absdiff_double(v1.z, v2.z);

	return rv;
}

Vec4<double> absdiff(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = absdiff_double(v1.x, v2.x);
	rv.y = absdiff_double(v1.y, v2.y);
	rv.z = absdiff_double(v1.z, v2.z);
	rv.w = absdiff_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> absdiff(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = absdiff_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double atan2(const double v1, const double v2) {
	return atan2_double(v1, v2);
}

Vec2<double> atan2(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = atan2_double(v1.x, v2.x);
	rv.y = atan2_double(v1.y, v2.y);

	return rv;
}

Vec3<double> atan2(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = atan2_double(v1.x, v2.x);
	rv.y = atan2_double(v1.y, v2.y);
	rv.z = atan2_double(v1.z, v2.z);

	return rv;
}

Vec4<double> atan2(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = atan2_double(v1.x, v2.x);
	rv.y = atan2_double(v1.y, v2.y);
	rv.z = atan2_double(v1.z, v2.z);
	rv.w = atan2_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> atan2(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = atan2_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double eq(const double v1, const double v2) {
	return eq_double(v1, v2);
}

Vec2<double> eq(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = eq_double(v1.x, v2.x);
	rv.y = eq_double(v1.y, v2.y);

	return rv;
}

Vec3<double> eq(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = eq_double(v1.x, v2.x);
	rv.y = eq_double(v1.y, v2.y);
	rv.z = eq_double(v1.z, v2.z);

	return rv;
}

Vec4<double> eq(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = eq_double(v1.x, v2.x);
	rv.y = eq_double(v1.y, v2.y);
	rv.z = eq_double(v1.z, v2.z);
	rv.w = eq_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> eq(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = eq_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double eqp(const double v1, const double v2) {
	return eqp_double(v1, v2);
}

Vec2<double> eqp(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = eqp_double(v1.x, v2.x);
	rv.y = eqp_double(v1.y, v2.y);

	return rv;
}

Vec3<double> eqp(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = eqp_double(v1.x, v2.x);
	rv.y = eqp_double(v1.y, v2.y);
	rv.z = eqp_double(v1.z, v2.z);

	return rv;
}

Vec4<double> eqp(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = eqp_double(v1.x, v2.x);
	rv.y = eqp_double(v1.y, v2.y);
	rv.z = eqp_double(v1.z, v2.z);
	rv.w = eqp_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> eqp(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = eqp_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double gt(const double v1, const double v2) {
	return gt_double(v1, v2);
}

Vec2<double> gt(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = gt_double(v1.x, v2.x);
	rv.y = gt_double(v1.y, v2.y);

	return rv;
}

Vec3<double> gt(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = gt_double(v1.x, v2.x);
	rv.y = gt_double(v1.y, v2.y);
	rv.z = gt_double(v1.z, v2.z);

	return rv;
}

Vec4<double> gt(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = gt_double(v1.x, v2.x);
	rv.y = gt_double(v1.y, v2.y);
	rv.z = gt_double(v1.z, v2.z);
	rv.w = gt_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> gt(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = gt_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double gte(const double v1, const double v2) {
	return gte_double(v1, v2);
}

Vec2<double> gte(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = gte_double(v1.x, v2.x);
	rv.y = gte_double(v1.y, v2.y);

	return rv;
}

Vec3<double> gte(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = gte_double(v1.x, v2.x);
	rv.y = gte_double(v1.y, v2.y);
	rv.z = gte_double(v1.z, v2.z);

	return rv;
}

Vec4<double> gte(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = gte_double(v1.x, v2.x);
	rv.y = gte_double(v1.y, v2.y);
	rv.z = gte_double(v1.z, v2.z);
	rv.w = gte_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> gte(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = gte_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double gtep(const double v1, const double v2) {
	return gtep_double(v1, v2);
}

Vec2<double> gtep(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = gtep_double(v1.x, v2.x);
	rv.y = gtep_double(v1.y, v2.y);

	return rv;
}

Vec3<double> gtep(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = gtep_double(v1.x, v2.x);
	rv.y = gtep_double(v1.y, v2.y);
	rv.z = gtep_double(v1.z, v2.z);

	return rv;
}

Vec4<double> gtep(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = gtep_double(v1.x, v2.x);
	rv.y = gtep_double(v1.y, v2.y);
	rv.z = gtep_double(v1.z, v2.z);
	rv.w = gtep_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> gtep(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = gtep_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double gtp(const double v1, const double v2) {
	return gtp_double(v1, v2);
}

Vec2<double> gtp(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = gtp_double(v1.x, v2.x);
	rv.y = gtp_double(v1.y, v2.y);

	return rv;
}

Vec3<double> gtp(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = gtp_double(v1.x, v2.x);
	rv.y = gtp_double(v1.y, v2.y);
	rv.z = gtp_double(v1.z, v2.z);

	return rv;
}

Vec4<double> gtp(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = gtp_double(v1.x, v2.x);
	rv.y = gtp_double(v1.y, v2.y);
	rv.z = gtp_double(v1.z, v2.z);
	rv.w = gtp_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> gtp(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = gtp_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double hypot(const double v1, const double v2) {
	return hypot_double(v1, v2);
}

Vec2<double> hypot(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = hypot_double(v1.x, v2.x);
	rv.y = hypot_double(v1.y, v2.y);

	return rv;
}

Vec3<double> hypot(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = hypot_double(v1.x, v2.x);
	rv.y = hypot_double(v1.y, v2.y);
	rv.z = hypot_double(v1.z, v2.z);

	return rv;
}

Vec4<double> hypot(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = hypot_double(v1.x, v2.x);
	rv.y = hypot_double(v1.y, v2.y);
	rv.z = hypot_double(v1.z, v2.z);
	rv.w = hypot_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> hypot(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = hypot_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double land(const double v1, const double v2) {
	return land_double(v1, v2);
}

Vec2<double> land(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = land_double(v1.x, v2.x);
	rv.y = land_double(v1.y, v2.y);

	return rv;
}

Vec3<double> land(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = land_double(v1.x, v2.x);
	rv.y = land_double(v1.y, v2.y);
	rv.z = land_double(v1.z, v2.z);

	return rv;
}

Vec4<double> land(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = land_double(v1.x, v2.x);
	rv.y = land_double(v1.y, v2.y);
	rv.z = land_double(v1.z, v2.z);
	rv.w = land_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> land(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = land_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double lor(const double v1, const double v2) {
	return lor_double(v1, v2);
}

Vec2<double> lor(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = lor_double(v1.x, v2.x);
	rv.y = lor_double(v1.y, v2.y);

	return rv;
}

Vec3<double> lor(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = lor_double(v1.x, v2.x);
	rv.y = lor_double(v1.y, v2.y);
	rv.z = lor_double(v1.z, v2.z);

	return rv;
}

Vec4<double> lor(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = lor_double(v1.x, v2.x);
	rv.y = lor_double(v1.y, v2.y);
	rv.z = lor_double(v1.z, v2.z);
	rv.w = lor_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> lor(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = lor_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double lt(const double v1, const double v2) {
	return lt_double(v1, v2);
}

Vec2<double> lt(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = lt_double(v1.x, v2.x);
	rv.y = lt_double(v1.y, v2.y);

	return rv;
}

Vec3<double> lt(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = lt_double(v1.x, v2.x);
	rv.y = lt_double(v1.y, v2.y);
	rv.z = lt_double(v1.z, v2.z);

	return rv;
}

Vec4<double> lt(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = lt_double(v1.x, v2.x);
	rv.y = lt_double(v1.y, v2.y);
	rv.z = lt_double(v1.z, v2.z);
	rv.w = lt_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> lt(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = lt_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double lte(const double v1, const double v2) {
	return lte_double(v1, v2);
}

Vec2<double> lte(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = lte_double(v1.x, v2.x);
	rv.y = lte_double(v1.y, v2.y);

	return rv;
}

Vec3<double> lte(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = lte_double(v1.x, v2.x);
	rv.y = lte_double(v1.y, v2.y);
	rv.z = lte_double(v1.z, v2.z);

	return rv;
}

Vec4<double> lte(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = lte_double(v1.x, v2.x);
	rv.y = lte_double(v1.y, v2.y);
	rv.z = lte_double(v1.z, v2.z);
	rv.w = lte_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> lte(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = lte_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double ltep(const double v1, const double v2) {
	return ltep_double(v1, v2);
}

Vec2<double> ltep(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = ltep_double(v1.x, v2.x);
	rv.y = ltep_double(v1.y, v2.y);

	return rv;
}

Vec3<double> ltep(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = ltep_double(v1.x, v2.x);
	rv.y = ltep_double(v1.y, v2.y);
	rv.z = ltep_double(v1.z, v2.z);

	return rv;
}

Vec4<double> ltep(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = ltep_double(v1.x, v2.x);
	rv.y = ltep_double(v1.y, v2.y);
	rv.z = ltep_double(v1.z, v2.z);
	rv.w = ltep_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> ltep(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = ltep_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double ltp(const double v1, const double v2) {
	return ltp_double(v1, v2);
}

Vec2<double> ltp(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = ltp_double(v1.x, v2.x);
	rv.y = ltp_double(v1.y, v2.y);

	return rv;
}

Vec3<double> ltp(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = ltp_double(v1.x, v2.x);
	rv.y = ltp_double(v1.y, v2.y);
	rv.z = ltp_double(v1.z, v2.z);

	return rv;
}

Vec4<double> ltp(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = ltp_double(v1.x, v2.x);
	rv.y = ltp_double(v1.y, v2.y);
	rv.z = ltp_double(v1.z, v2.z);
	rv.w = ltp_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> ltp(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = ltp_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double max(const double v1, const double v2) {
	return max_double(v1, v2);
}

Vec2<double> max(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = max_double(v1.x, v2.x);
	rv.y = max_double(v1.y, v2.y);

	return rv;
}

Vec3<double> max(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = max_double(v1.x, v2.x);
	rv.y = max_double(v1.y, v2.y);
	rv.z = max_double(v1.z, v2.z);

	return rv;
}

Vec4<double> max(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = max_double(v1.x, v2.x);
	rv.y = max_double(v1.y, v2.y);
	rv.z = max_double(v1.z, v2.z);
	rv.w = max_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> max(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = max_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double min(const double v1, const double v2) {
	return min_double(v1, v2);
}

Vec2<double> min(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = min_double(v1.x, v2.x);
	rv.y = min_double(v1.y, v2.y);

	return rv;
}

Vec3<double> min(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = min_double(v1.x, v2.x);
	rv.y = min_double(v1.y, v2.y);
	rv.z = min_double(v1.z, v2.z);

	return rv;
}

Vec4<double> min(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = min_double(v1.x, v2.x);
	rv.y = min_double(v1.y, v2.y);
	rv.z = min_double(v1.z, v2.z);
	rv.w = min_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> min(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = min_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double mod(const double v1, const double v2) {
	return mod_double(v1, v2);
}

Vec2<double> mod(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = mod_double(v1.x, v2.x);
	rv.y = mod_double(v1.y, v2.y);

	return rv;
}

Vec3<double> mod(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = mod_double(v1.x, v2.x);
	rv.y = mod_double(v1.y, v2.y);
	rv.z = mod_double(v1.z, v2.z);

	return rv;
}

Vec4<double> mod(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = mod_double(v1.x, v2.x);
	rv.y = mod_double(v1.y, v2.y);
	rv.z = mod_double(v1.z, v2.z);
	rv.w = mod_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> mod(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = mod_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double neq(const double v1, const double v2) {
	return neq_double(v1, v2);
}

Vec2<double> neq(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = neq_double(v1.x, v2.x);
	rv.y = neq_double(v1.y, v2.y);

	return rv;
}

Vec3<double> neq(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = neq_double(v1.x, v2.x);
	rv.y = neq_double(v1.y, v2.y);
	rv.z = neq_double(v1.z, v2.z);

	return rv;
}

Vec4<double> neq(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = neq_double(v1.x, v2.x);
	rv.y = neq_double(v1.y, v2.y);
	rv.z = neq_double(v1.z, v2.z);
	rv.w = neq_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> neq(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = neq_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double neqp(const double v1, const double v2) {
	return neqp_double(v1, v2);
}

Vec2<double> neqp(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = neqp_double(v1.x, v2.x);
	rv.y = neqp_double(v1.y, v2.y);

	return rv;
}

Vec3<double> neqp(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = neqp_double(v1.x, v2.x);
	rv.y = neqp_double(v1.y, v2.y);
	rv.z = neqp_double(v1.z, v2.z);

	return rv;
}

Vec4<double> neqp(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = neqp_double(v1.x, v2.x);
	rv.y = neqp_double(v1.y, v2.y);
	rv.z = neqp_double(v1.z, v2.z);
	rv.w = neqp_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> neqp(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = neqp_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double pow(const double v1, const double v2) {
	return pow_double(v1, v2);
}

Vec2<double> pow(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = pow_double(v1.x, v2.x);
	rv.y = pow_double(v1.y, v2.y);

	return rv;
}

Vec3<double> pow(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = pow_double(v1.x, v2.x);
	rv.y = pow_double(v1.y, v2.y);
	rv.z = pow_double(v1.z, v2.z);

	return rv;
}

Vec4<double> pow(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = pow_double(v1.x, v2.x);
	rv.y = pow_double(v1.y, v2.y);
	rv.z = pow_double(v1.z, v2.z);
	rv.w = pow_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> pow(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = pow_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double lxor(const double v1, const double v2) {
	return lxor_double(v1, v2);
}

Vec2<double> lxor(const Vec2<double> &v1, const Vec2<double> &v2) {
	Vec2<double> rv;
	rv.x = lxor_double(v1.x, v2.x);
	rv.y = lxor_double(v1.y, v2.y);

	return rv;
}

Vec3<double> lxor(const Vec3<double> &v1, const Vec3<double> &v2) {
	Vec3<double> rv;
	rv.x = lxor_double(v1.x, v2.x);
	rv.y = lxor_double(v1.y, v2.y);
	rv.z = lxor_double(v1.z, v2.z);

	return rv;
}

Vec4<double> lxor(const Vec4<double> &v1, const Vec4<double> &v2) {
	Vec4<double> rv;
	rv.x = lxor_double(v1.x, v2.x);
	rv.y = lxor_double(v1.y, v2.y);
	rv.z = lxor_double(v1.z, v2.z);
	rv.w = lxor_double(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<double, N> lxor(const VecN<double, N> &v1, const VecN<double, N> &v2) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = lxor_double(v1.v[i], v2.v[i]);
	}
	return rv;
}

double foldop(const double v1, const double v2, const double v3) {
	return foldop_double(v1, v2, v3);
}

Vec2<double> foldop(
	const Vec2<double> &v1, 
	const Vec2<double> &v2, 
	const Vec2<double> &v3
) {
	Vec2<double> rv;
	rv.x = foldop_double(v1.x, v2.x, v3.x);
	rv.y = foldop_double(v1.y, v2.y, v3.y);

	return rv;
}

Vec3<double> foldop(
	const Vec3<double> &v1, 
	const Vec3<double> &v2, 
	const Vec3<double> &v3
) {
	Vec3<double> rv;
	rv.x = foldop_double(v1.x, v2.x, v3.x);
	rv.y = foldop_double(v1.y, v2.y, v3.y);
	rv.z = foldop_double(v1.z, v2.z, v3.z);

	return rv;
}

Vec4<double> foldop(
	const Vec4<double> &v1, 
	const Vec4<double> &v2, 
	const Vec4<double> &v3
) {
	Vec4<double> rv;
	rv.x = foldop_double(v1.x, v2.x, v3.x);
	rv.y = foldop_double(v1.y, v2.y, v3.y);
	rv.z = foldop_double(v1.z, v2.z, v3.z);
	rv.w = foldop_double(v1.w, v2.w, v3.w);

	return rv;
}

template <unsigned N>
VecN<double, N> foldop(
	const VecN<double, N> &v1, 
	const VecN<double, N> &v2,
	const VecN<double, N> &v3
) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = foldop_double(v1.v[i], v2.v[i], v3.v[i]);
	}
	return rv;
}

double smoothstep(const double v1, const double v2, const double v3) {
	return smoothstep_double(v1, v2, v3);
}

Vec2<double> smoothstep(
	const Vec2<double> &v1, 
	const Vec2<double> &v2, 
	const Vec2<double> &v3
) {
	Vec2<double> rv;
	rv.x = smoothstep_double(v1.x, v2.x, v3.x);
	rv.y = smoothstep_double(v1.y, v2.y, v3.y);

	return rv;
}

Vec3<double> smoothstep(
	const Vec3<double> &v1, 
	const Vec3<double> &v2, 
	const Vec3<double> &v3
) {
	Vec3<double> rv;
	rv.x = smoothstep_double(v1.x, v2.x, v3.x);
	rv.y = smoothstep_double(v1.y, v2.y, v3.y);
	rv.z = smoothstep_double(v1.z, v2.z, v3.z);

	return rv;
}

Vec4<double> smoothstep(
	const Vec4<double> &v1, 
	const Vec4<double> &v2, 
	const Vec4<double> &v3
) {
	Vec4<double> rv;
	rv.x = smoothstep_double(v1.x, v2.x, v3.x);
	rv.y = smoothstep_double(v1.y, v2.y, v3.y);
	rv.z = smoothstep_double(v1.z, v2.z, v3.z);
	rv.w = smoothstep_double(v1.w, v2.w, v3.w);

	return rv;
}

template <unsigned N>
VecN<double, N> smoothstep(
	const VecN<double, N> &v1, 
	const VecN<double, N> &v2,
	const VecN<double, N> &v3
) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = smoothstep_double(v1.v[i], v2.v[i], v3.v[i]);
	}
	return rv;
}

double switchop(const double v1, const double v2, const double v3) {
	return switchop_double(v1, v2, v3);
}

Vec2<double> switchop(
	const Vec2<double> &v1, 
	const Vec2<double> &v2, 
	const Vec2<double> &v3
) {
	Vec2<double> rv;
	rv.x = switchop_double(v1.x, v2.x, v3.x);
	rv.y = switchop_double(v1.y, v2.y, v3.y);

	return rv;
}

Vec3<double> switchop(
	const Vec3<double> &v1, 
	const Vec3<double> &v2, 
	const Vec3<double> &v3
) {
	Vec3<double> rv;
	rv.x = switchop_double(v1.x, v2.x, v3.x);
	rv.y = switchop_double(v1.y, v2.y, v3.y);
	rv.z = switchop_double(v1.z, v2.z, v3.z);

	return rv;
}

Vec4<double> switchop(
	const Vec4<double> &v1, 
	const Vec4<double> &v2, 
	const Vec4<double> &v3
) {
	Vec4<double> rv;
	rv.x = switchop_double(v1.x, v2.x, v3.x);
	rv.y = switchop_double(v1.y, v2.y, v3.y);
	rv.z = switchop_double(v1.z, v2.z, v3.z);
	rv.w = switchop_double(v1.w, v2.w, v3.w);

	return rv;
}

template <unsigned N>
VecN<double, N> switchop(
	const VecN<double, N> &v1, 
	const VecN<double, N> &v2,
	const VecN<double, N> &v3
) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = switchop_double(v1.v[i], v2.v[i], v3.v[i]);
	}
	return rv;
}

double wrapop(const double v1, const double v2, const double v3) {
	return wrapop_double(v1, v2, v3);
}

Vec2<double> wrapop(
	const Vec2<double> &v1, 
	const Vec2<double> &v2, 
	const Vec2<double> &v3
) {
	Vec2<double> rv;
	rv.x = wrapop_double(v1.x, v2.x, v3.x);
	rv.y = wrapop_double(v1.y, v2.y, v3.y);

	return rv;
}

Vec3<double> wrapop(
	const Vec3<double> &v1, 
	const Vec3<double> &v2, 
	const Vec3<double> &v3
) {
	Vec3<double> rv;
	rv.x = wrapop_double(v1.x, v2.x, v3.x);
	rv.y = wrapop_double(v1.y, v2.y, v3.y);
	rv.z = wrapop_double(v1.z, v2.z, v3.z);

	return rv;
}

Vec4<double> wrapop(
	const Vec4<double> &v1, 
	const Vec4<double> &v2, 
	const Vec4<double> &v3
) {
	Vec4<double> rv;
	rv.x = wrapop_double(v1.x, v2.x, v3.x);
	rv.y = wrapop_double(v1.y, v2.y, v3.y);
	rv.z = wrapop_double(v1.z, v2.z, v3.z);
	rv.w = wrapop_double(v1.w, v2.w, v3.w);

	return rv;
}

template <unsigned N>
VecN<double, N> wrapop(
	const VecN<double, N> &v1, 
	const VecN<double, N> &v2,
	const VecN<double, N> &v3
) {
	VecN<double, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = wrapop_double(v1.v[i], v2.v[i], v3.v[i]);
	}
	return rv;
}



#endif // JIT_CODEGEN_OP_DOUBLE_HPP
