// This file automagically generated, do not edit
#ifndef JIT_CODEGEN_OP_FLOAT_HPP
#define JIT_CODEGEN_OP_FLOAT_HPP 1
#include "math.codegen.h"
#include "jit.codegen.vec.hpp"
#include "jit.codegen.op.hpp"

float abs(const float v) {
	return abs_float(v);
}

Vec2<float> abs(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = abs_float(v.x);
	rv.y = abs_float(v.y);

	return rv;
}

Vec3<float> abs(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = abs_float(v.x);
	rv.y = abs_float(v.y);
	rv.z = abs_float(v.z);

	return rv;
}

Vec4<float> abs(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = abs_float(v.x);
	rv.y = abs_float(v.y);
	rv.z = abs_float(v.z);
	rv.w = abs_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> abs(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = abs_float(v.v[i]);
	}
	return rv;
}

float acos(const float v) {
	return acos_float(v);
}

Vec2<float> acos(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = acos_float(v.x);
	rv.y = acos_float(v.y);

	return rv;
}

Vec3<float> acos(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = acos_float(v.x);
	rv.y = acos_float(v.y);
	rv.z = acos_float(v.z);

	return rv;
}

Vec4<float> acos(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = acos_float(v.x);
	rv.y = acos_float(v.y);
	rv.z = acos_float(v.z);
	rv.w = acos_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> acos(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = acos_float(v.v[i]);
	}
	return rv;
}

float acosh(const float v) {
	return acosh_float(v);
}

Vec2<float> acosh(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = acosh_float(v.x);
	rv.y = acosh_float(v.y);

	return rv;
}

Vec3<float> acosh(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = acosh_float(v.x);
	rv.y = acosh_float(v.y);
	rv.z = acosh_float(v.z);

	return rv;
}

Vec4<float> acosh(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = acosh_float(v.x);
	rv.y = acosh_float(v.y);
	rv.z = acosh_float(v.z);
	rv.w = acosh_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> acosh(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = acosh_float(v.v[i]);
	}
	return rv;
}

float asin(const float v) {
	return asin_float(v);
}

Vec2<float> asin(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = asin_float(v.x);
	rv.y = asin_float(v.y);

	return rv;
}

Vec3<float> asin(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = asin_float(v.x);
	rv.y = asin_float(v.y);
	rv.z = asin_float(v.z);

	return rv;
}

Vec4<float> asin(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = asin_float(v.x);
	rv.y = asin_float(v.y);
	rv.z = asin_float(v.z);
	rv.w = asin_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> asin(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = asin_float(v.v[i]);
	}
	return rv;
}

float asinh(const float v) {
	return asinh_float(v);
}

Vec2<float> asinh(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = asinh_float(v.x);
	rv.y = asinh_float(v.y);

	return rv;
}

Vec3<float> asinh(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = asinh_float(v.x);
	rv.y = asinh_float(v.y);
	rv.z = asinh_float(v.z);

	return rv;
}

Vec4<float> asinh(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = asinh_float(v.x);
	rv.y = asinh_float(v.y);
	rv.z = asinh_float(v.z);
	rv.w = asinh_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> asinh(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = asinh_float(v.v[i]);
	}
	return rv;
}

float atan(const float v) {
	return atan_float(v);
}

Vec2<float> atan(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = atan_float(v.x);
	rv.y = atan_float(v.y);

	return rv;
}

Vec3<float> atan(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = atan_float(v.x);
	rv.y = atan_float(v.y);
	rv.z = atan_float(v.z);

	return rv;
}

Vec4<float> atan(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = atan_float(v.x);
	rv.y = atan_float(v.y);
	rv.z = atan_float(v.z);
	rv.w = atan_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> atan(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = atan_float(v.v[i]);
	}
	return rv;
}

float atanh(const float v) {
	return atanh_float(v);
}

Vec2<float> atanh(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = atanh_float(v.x);
	rv.y = atanh_float(v.y);

	return rv;
}

Vec3<float> atanh(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = atanh_float(v.x);
	rv.y = atanh_float(v.y);
	rv.z = atanh_float(v.z);

	return rv;
}

Vec4<float> atanh(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = atanh_float(v.x);
	rv.y = atanh_float(v.y);
	rv.z = atanh_float(v.z);
	rv.w = atanh_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> atanh(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = atanh_float(v.v[i]);
	}
	return rv;
}

float ceil(const float v) {
	return ceil_float(v);
}

Vec2<float> ceil(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = ceil_float(v.x);
	rv.y = ceil_float(v.y);

	return rv;
}

Vec3<float> ceil(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = ceil_float(v.x);
	rv.y = ceil_float(v.y);
	rv.z = ceil_float(v.z);

	return rv;
}

Vec4<float> ceil(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = ceil_float(v.x);
	rv.y = ceil_float(v.y);
	rv.z = ceil_float(v.z);
	rv.w = ceil_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> ceil(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = ceil_float(v.v[i]);
	}
	return rv;
}

float cos(const float v) {
	return cos_float(v);
}

Vec2<float> cos(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = cos_float(v.x);
	rv.y = cos_float(v.y);

	return rv;
}

Vec3<float> cos(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = cos_float(v.x);
	rv.y = cos_float(v.y);
	rv.z = cos_float(v.z);

	return rv;
}

Vec4<float> cos(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = cos_float(v.x);
	rv.y = cos_float(v.y);
	rv.z = cos_float(v.z);
	rv.w = cos_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> cos(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = cos_float(v.v[i]);
	}
	return rv;
}

float cosh(const float v) {
	return cosh_float(v);
}

Vec2<float> cosh(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = cosh_float(v.x);
	rv.y = cosh_float(v.y);

	return rv;
}

Vec3<float> cosh(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = cosh_float(v.x);
	rv.y = cosh_float(v.y);
	rv.z = cosh_float(v.z);

	return rv;
}

Vec4<float> cosh(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = cosh_float(v.x);
	rv.y = cosh_float(v.y);
	rv.z = cosh_float(v.z);
	rv.w = cosh_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> cosh(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = cosh_float(v.v[i]);
	}
	return rv;
}

float exp(const float v) {
	return exp_float(v);
}

Vec2<float> exp(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = exp_float(v.x);
	rv.y = exp_float(v.y);

	return rv;
}

Vec3<float> exp(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = exp_float(v.x);
	rv.y = exp_float(v.y);
	rv.z = exp_float(v.z);

	return rv;
}

Vec4<float> exp(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = exp_float(v.x);
	rv.y = exp_float(v.y);
	rv.z = exp_float(v.z);
	rv.w = exp_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> exp(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = exp_float(v.v[i]);
	}
	return rv;
}

float exp2(const float v) {
	return exp2_float(v);
}

Vec2<float> exp2(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = exp2_float(v.x);
	rv.y = exp2_float(v.y);

	return rv;
}

Vec3<float> exp2(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = exp2_float(v.x);
	rv.y = exp2_float(v.y);
	rv.z = exp2_float(v.z);

	return rv;
}

Vec4<float> exp2(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = exp2_float(v.x);
	rv.y = exp2_float(v.y);
	rv.z = exp2_float(v.z);
	rv.w = exp2_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> exp2(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = exp2_float(v.v[i]);
	}
	return rv;
}

float floor(const float v) {
	return floor_float(v);
}

Vec2<float> floor(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = floor_float(v.x);
	rv.y = floor_float(v.y);

	return rv;
}

Vec3<float> floor(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = floor_float(v.x);
	rv.y = floor_float(v.y);
	rv.z = floor_float(v.z);

	return rv;
}

Vec4<float> floor(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = floor_float(v.x);
	rv.y = floor_float(v.y);
	rv.z = floor_float(v.z);
	rv.w = floor_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> floor(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = floor_float(v.v[i]);
	}
	return rv;
}

float fract(const float v) {
	return fract_float(v);
}

Vec2<float> fract(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = fract_float(v.x);
	rv.y = fract_float(v.y);

	return rv;
}

Vec3<float> fract(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = fract_float(v.x);
	rv.y = fract_float(v.y);
	rv.z = fract_float(v.z);

	return rv;
}

Vec4<float> fract(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = fract_float(v.x);
	rv.y = fract_float(v.y);
	rv.z = fract_float(v.z);
	rv.w = fract_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> fract(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = fract_float(v.v[i]);
	}
	return rv;
}

float log(const float v) {
	return log_float(v);
}

Vec2<float> log(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = log_float(v.x);
	rv.y = log_float(v.y);

	return rv;
}

Vec3<float> log(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = log_float(v.x);
	rv.y = log_float(v.y);
	rv.z = log_float(v.z);

	return rv;
}

Vec4<float> log(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = log_float(v.x);
	rv.y = log_float(v.y);
	rv.z = log_float(v.z);
	rv.w = log_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> log(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = log_float(v.v[i]);
	}
	return rv;
}

float log2(const float v) {
	return log2_float(v);
}

Vec2<float> log2(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = log2_float(v.x);
	rv.y = log2_float(v.y);

	return rv;
}

Vec3<float> log2(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = log2_float(v.x);
	rv.y = log2_float(v.y);
	rv.z = log2_float(v.z);

	return rv;
}

Vec4<float> log2(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = log2_float(v.x);
	rv.y = log2_float(v.y);
	rv.z = log2_float(v.z);
	rv.w = log2_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> log2(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = log2_float(v.v[i]);
	}
	return rv;
}

float log10(const float v) {
	return log10_float(v);
}

Vec2<float> log10(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = log10_float(v.x);
	rv.y = log10_float(v.y);

	return rv;
}

Vec3<float> log10(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = log10_float(v.x);
	rv.y = log10_float(v.y);
	rv.z = log10_float(v.z);

	return rv;
}

Vec4<float> log10(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = log10_float(v.x);
	rv.y = log10_float(v.y);
	rv.z = log10_float(v.z);
	rv.w = log10_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> log10(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = log10_float(v.v[i]);
	}
	return rv;
}

float lnot(const float v) {
	return lnot_float(v);
}

Vec2<float> lnot(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = lnot_float(v.x);
	rv.y = lnot_float(v.y);

	return rv;
}

Vec3<float> lnot(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = lnot_float(v.x);
	rv.y = lnot_float(v.y);
	rv.z = lnot_float(v.z);

	return rv;
}

Vec4<float> lnot(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = lnot_float(v.x);
	rv.y = lnot_float(v.y);
	rv.z = lnot_float(v.z);
	rv.w = lnot_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> lnot(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = lnot_float(v.v[i]);
	}
	return rv;
}

float round(const float v) {
	return round_float(v);
}

Vec2<float> round(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = round_float(v.x);
	rv.y = round_float(v.y);

	return rv;
}

Vec3<float> round(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = round_float(v.x);
	rv.y = round_float(v.y);
	rv.z = round_float(v.z);

	return rv;
}

Vec4<float> round(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = round_float(v.x);
	rv.y = round_float(v.y);
	rv.z = round_float(v.z);
	rv.w = round_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> round(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = round_float(v.v[i]);
	}
	return rv;
}

float sign(const float v) {
	return sign_float(v);
}

Vec2<float> sign(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = sign_float(v.x);
	rv.y = sign_float(v.y);

	return rv;
}

Vec3<float> sign(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = sign_float(v.x);
	rv.y = sign_float(v.y);
	rv.z = sign_float(v.z);

	return rv;
}

Vec4<float> sign(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = sign_float(v.x);
	rv.y = sign_float(v.y);
	rv.z = sign_float(v.z);
	rv.w = sign_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> sign(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = sign_float(v.v[i]);
	}
	return rv;
}

float sin(const float v) {
	return sin_float(v);
}

Vec2<float> sin(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = sin_float(v.x);
	rv.y = sin_float(v.y);

	return rv;
}

Vec3<float> sin(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = sin_float(v.x);
	rv.y = sin_float(v.y);
	rv.z = sin_float(v.z);

	return rv;
}

Vec4<float> sin(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = sin_float(v.x);
	rv.y = sin_float(v.y);
	rv.z = sin_float(v.z);
	rv.w = sin_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> sin(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = sin_float(v.v[i]);
	}
	return rv;
}

float sinh(const float v) {
	return sinh_float(v);
}

Vec2<float> sinh(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = sinh_float(v.x);
	rv.y = sinh_float(v.y);

	return rv;
}

Vec3<float> sinh(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = sinh_float(v.x);
	rv.y = sinh_float(v.y);
	rv.z = sinh_float(v.z);

	return rv;
}

Vec4<float> sinh(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = sinh_float(v.x);
	rv.y = sinh_float(v.y);
	rv.z = sinh_float(v.z);
	rv.w = sinh_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> sinh(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = sinh_float(v.v[i]);
	}
	return rv;
}

float sqrt(const float v) {
	return sqrt_float(v);
}

Vec2<float> sqrt(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = sqrt_float(v.x);
	rv.y = sqrt_float(v.y);

	return rv;
}

Vec3<float> sqrt(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = sqrt_float(v.x);
	rv.y = sqrt_float(v.y);
	rv.z = sqrt_float(v.z);

	return rv;
}

Vec4<float> sqrt(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = sqrt_float(v.x);
	rv.y = sqrt_float(v.y);
	rv.z = sqrt_float(v.z);
	rv.w = sqrt_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> sqrt(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = sqrt_float(v.v[i]);
	}
	return rv;
}

float tan(const float v) {
	return tan_float(v);
}

Vec2<float> tan(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = tan_float(v.x);
	rv.y = tan_float(v.y);

	return rv;
}

Vec3<float> tan(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = tan_float(v.x);
	rv.y = tan_float(v.y);
	rv.z = tan_float(v.z);

	return rv;
}

Vec4<float> tan(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = tan_float(v.x);
	rv.y = tan_float(v.y);
	rv.z = tan_float(v.z);
	rv.w = tan_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> tan(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = tan_float(v.v[i]);
	}
	return rv;
}

float tanh(const float v) {
	return tanh_float(v);
}

Vec2<float> tanh(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = tanh_float(v.x);
	rv.y = tanh_float(v.y);

	return rv;
}

Vec3<float> tanh(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = tanh_float(v.x);
	rv.y = tanh_float(v.y);
	rv.z = tanh_float(v.z);

	return rv;
}

Vec4<float> tanh(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = tanh_float(v.x);
	rv.y = tanh_float(v.y);
	rv.z = tanh_float(v.z);
	rv.w = tanh_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> tanh(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = tanh_float(v.v[i]);
	}
	return rv;
}

float trunc(const float v) {
	return trunc_float(v);
}

Vec2<float> trunc(const Vec2<float> &v) {
	Vec2<float> rv;
	rv.x = trunc_float(v.x);
	rv.y = trunc_float(v.y);

	return rv;
}

Vec3<float> trunc(const Vec3<float> &v) {
	Vec3<float> rv;
	rv.x = trunc_float(v.x);
	rv.y = trunc_float(v.y);
	rv.z = trunc_float(v.z);

	return rv;
}

Vec4<float> trunc(const Vec4<float> &v) {
	Vec4<float> rv;
	rv.x = trunc_float(v.x);
	rv.y = trunc_float(v.y);
	rv.z = trunc_float(v.z);
	rv.w = trunc_float(v.w);

	return rv;
}

template <unsigned N>
VecN<float, N> trunc(const VecN<float, N> &v) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = trunc_float(v.v[i]);
	}
	return rv;
}

float absdiff(const float v1, const float v2) {
	return absdiff_float(v1, v2);
}

Vec2<float> absdiff(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = absdiff_float(v1.x, v2.x);
	rv.y = absdiff_float(v1.y, v2.y);

	return rv;
}

Vec3<float> absdiff(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = absdiff_float(v1.x, v2.x);
	rv.y = absdiff_float(v1.y, v2.y);
	rv.z = absdiff_float(v1.z, v2.z);

	return rv;
}

Vec4<float> absdiff(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = absdiff_float(v1.x, v2.x);
	rv.y = absdiff_float(v1.y, v2.y);
	rv.z = absdiff_float(v1.z, v2.z);
	rv.w = absdiff_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> absdiff(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = absdiff_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float atan2(const float v1, const float v2) {
	return atan2_float(v1, v2);
}

Vec2<float> atan2(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = atan2_float(v1.x, v2.x);
	rv.y = atan2_float(v1.y, v2.y);

	return rv;
}

Vec3<float> atan2(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = atan2_float(v1.x, v2.x);
	rv.y = atan2_float(v1.y, v2.y);
	rv.z = atan2_float(v1.z, v2.z);

	return rv;
}

Vec4<float> atan2(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = atan2_float(v1.x, v2.x);
	rv.y = atan2_float(v1.y, v2.y);
	rv.z = atan2_float(v1.z, v2.z);
	rv.w = atan2_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> atan2(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = atan2_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float eq(const float v1, const float v2) {
	return eq_float(v1, v2);
}

Vec2<float> eq(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = eq_float(v1.x, v2.x);
	rv.y = eq_float(v1.y, v2.y);

	return rv;
}

Vec3<float> eq(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = eq_float(v1.x, v2.x);
	rv.y = eq_float(v1.y, v2.y);
	rv.z = eq_float(v1.z, v2.z);

	return rv;
}

Vec4<float> eq(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = eq_float(v1.x, v2.x);
	rv.y = eq_float(v1.y, v2.y);
	rv.z = eq_float(v1.z, v2.z);
	rv.w = eq_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> eq(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = eq_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float eqp(const float v1, const float v2) {
	return eqp_float(v1, v2);
}

Vec2<float> eqp(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = eqp_float(v1.x, v2.x);
	rv.y = eqp_float(v1.y, v2.y);

	return rv;
}

Vec3<float> eqp(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = eqp_float(v1.x, v2.x);
	rv.y = eqp_float(v1.y, v2.y);
	rv.z = eqp_float(v1.z, v2.z);

	return rv;
}

Vec4<float> eqp(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = eqp_float(v1.x, v2.x);
	rv.y = eqp_float(v1.y, v2.y);
	rv.z = eqp_float(v1.z, v2.z);
	rv.w = eqp_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> eqp(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = eqp_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float gt(const float v1, const float v2) {
	return gt_float(v1, v2);
}

Vec2<float> gt(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = gt_float(v1.x, v2.x);
	rv.y = gt_float(v1.y, v2.y);

	return rv;
}

Vec3<float> gt(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = gt_float(v1.x, v2.x);
	rv.y = gt_float(v1.y, v2.y);
	rv.z = gt_float(v1.z, v2.z);

	return rv;
}

Vec4<float> gt(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = gt_float(v1.x, v2.x);
	rv.y = gt_float(v1.y, v2.y);
	rv.z = gt_float(v1.z, v2.z);
	rv.w = gt_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> gt(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = gt_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float gte(const float v1, const float v2) {
	return gte_float(v1, v2);
}

Vec2<float> gte(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = gte_float(v1.x, v2.x);
	rv.y = gte_float(v1.y, v2.y);

	return rv;
}

Vec3<float> gte(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = gte_float(v1.x, v2.x);
	rv.y = gte_float(v1.y, v2.y);
	rv.z = gte_float(v1.z, v2.z);

	return rv;
}

Vec4<float> gte(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = gte_float(v1.x, v2.x);
	rv.y = gte_float(v1.y, v2.y);
	rv.z = gte_float(v1.z, v2.z);
	rv.w = gte_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> gte(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = gte_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float gtep(const float v1, const float v2) {
	return gtep_float(v1, v2);
}

Vec2<float> gtep(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = gtep_float(v1.x, v2.x);
	rv.y = gtep_float(v1.y, v2.y);

	return rv;
}

Vec3<float> gtep(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = gtep_float(v1.x, v2.x);
	rv.y = gtep_float(v1.y, v2.y);
	rv.z = gtep_float(v1.z, v2.z);

	return rv;
}

Vec4<float> gtep(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = gtep_float(v1.x, v2.x);
	rv.y = gtep_float(v1.y, v2.y);
	rv.z = gtep_float(v1.z, v2.z);
	rv.w = gtep_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> gtep(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = gtep_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float gtp(const float v1, const float v2) {
	return gtp_float(v1, v2);
}

Vec2<float> gtp(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = gtp_float(v1.x, v2.x);
	rv.y = gtp_float(v1.y, v2.y);

	return rv;
}

Vec3<float> gtp(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = gtp_float(v1.x, v2.x);
	rv.y = gtp_float(v1.y, v2.y);
	rv.z = gtp_float(v1.z, v2.z);

	return rv;
}

Vec4<float> gtp(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = gtp_float(v1.x, v2.x);
	rv.y = gtp_float(v1.y, v2.y);
	rv.z = gtp_float(v1.z, v2.z);
	rv.w = gtp_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> gtp(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = gtp_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float hypot(const float v1, const float v2) {
	return hypot_float(v1, v2);
}

Vec2<float> hypot(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = hypot_float(v1.x, v2.x);
	rv.y = hypot_float(v1.y, v2.y);

	return rv;
}

Vec3<float> hypot(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = hypot_float(v1.x, v2.x);
	rv.y = hypot_float(v1.y, v2.y);
	rv.z = hypot_float(v1.z, v2.z);

	return rv;
}

Vec4<float> hypot(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = hypot_float(v1.x, v2.x);
	rv.y = hypot_float(v1.y, v2.y);
	rv.z = hypot_float(v1.z, v2.z);
	rv.w = hypot_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> hypot(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = hypot_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float land(const float v1, const float v2) {
	return land_float(v1, v2);
}

Vec2<float> land(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = land_float(v1.x, v2.x);
	rv.y = land_float(v1.y, v2.y);

	return rv;
}

Vec3<float> land(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = land_float(v1.x, v2.x);
	rv.y = land_float(v1.y, v2.y);
	rv.z = land_float(v1.z, v2.z);

	return rv;
}

Vec4<float> land(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = land_float(v1.x, v2.x);
	rv.y = land_float(v1.y, v2.y);
	rv.z = land_float(v1.z, v2.z);
	rv.w = land_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> land(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = land_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float lor(const float v1, const float v2) {
	return lor_float(v1, v2);
}

Vec2<float> lor(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = lor_float(v1.x, v2.x);
	rv.y = lor_float(v1.y, v2.y);

	return rv;
}

Vec3<float> lor(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = lor_float(v1.x, v2.x);
	rv.y = lor_float(v1.y, v2.y);
	rv.z = lor_float(v1.z, v2.z);

	return rv;
}

Vec4<float> lor(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = lor_float(v1.x, v2.x);
	rv.y = lor_float(v1.y, v2.y);
	rv.z = lor_float(v1.z, v2.z);
	rv.w = lor_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> lor(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = lor_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float lt(const float v1, const float v2) {
	return lt_float(v1, v2);
}

Vec2<float> lt(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = lt_float(v1.x, v2.x);
	rv.y = lt_float(v1.y, v2.y);

	return rv;
}

Vec3<float> lt(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = lt_float(v1.x, v2.x);
	rv.y = lt_float(v1.y, v2.y);
	rv.z = lt_float(v1.z, v2.z);

	return rv;
}

Vec4<float> lt(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = lt_float(v1.x, v2.x);
	rv.y = lt_float(v1.y, v2.y);
	rv.z = lt_float(v1.z, v2.z);
	rv.w = lt_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> lt(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = lt_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float lte(const float v1, const float v2) {
	return lte_float(v1, v2);
}

Vec2<float> lte(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = lte_float(v1.x, v2.x);
	rv.y = lte_float(v1.y, v2.y);

	return rv;
}

Vec3<float> lte(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = lte_float(v1.x, v2.x);
	rv.y = lte_float(v1.y, v2.y);
	rv.z = lte_float(v1.z, v2.z);

	return rv;
}

Vec4<float> lte(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = lte_float(v1.x, v2.x);
	rv.y = lte_float(v1.y, v2.y);
	rv.z = lte_float(v1.z, v2.z);
	rv.w = lte_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> lte(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = lte_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float ltep(const float v1, const float v2) {
	return ltep_float(v1, v2);
}

Vec2<float> ltep(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = ltep_float(v1.x, v2.x);
	rv.y = ltep_float(v1.y, v2.y);

	return rv;
}

Vec3<float> ltep(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = ltep_float(v1.x, v2.x);
	rv.y = ltep_float(v1.y, v2.y);
	rv.z = ltep_float(v1.z, v2.z);

	return rv;
}

Vec4<float> ltep(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = ltep_float(v1.x, v2.x);
	rv.y = ltep_float(v1.y, v2.y);
	rv.z = ltep_float(v1.z, v2.z);
	rv.w = ltep_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> ltep(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = ltep_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float ltp(const float v1, const float v2) {
	return ltp_float(v1, v2);
}

Vec2<float> ltp(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = ltp_float(v1.x, v2.x);
	rv.y = ltp_float(v1.y, v2.y);

	return rv;
}

Vec3<float> ltp(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = ltp_float(v1.x, v2.x);
	rv.y = ltp_float(v1.y, v2.y);
	rv.z = ltp_float(v1.z, v2.z);

	return rv;
}

Vec4<float> ltp(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = ltp_float(v1.x, v2.x);
	rv.y = ltp_float(v1.y, v2.y);
	rv.z = ltp_float(v1.z, v2.z);
	rv.w = ltp_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> ltp(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = ltp_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float max(const float v1, const float v2) {
	return max_float(v1, v2);
}

Vec2<float> max(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = max_float(v1.x, v2.x);
	rv.y = max_float(v1.y, v2.y);

	return rv;
}

Vec3<float> max(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = max_float(v1.x, v2.x);
	rv.y = max_float(v1.y, v2.y);
	rv.z = max_float(v1.z, v2.z);

	return rv;
}

Vec4<float> max(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = max_float(v1.x, v2.x);
	rv.y = max_float(v1.y, v2.y);
	rv.z = max_float(v1.z, v2.z);
	rv.w = max_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> max(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = max_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float min(const float v1, const float v2) {
	return min_float(v1, v2);
}

Vec2<float> min(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = min_float(v1.x, v2.x);
	rv.y = min_float(v1.y, v2.y);

	return rv;
}

Vec3<float> min(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = min_float(v1.x, v2.x);
	rv.y = min_float(v1.y, v2.y);
	rv.z = min_float(v1.z, v2.z);

	return rv;
}

Vec4<float> min(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = min_float(v1.x, v2.x);
	rv.y = min_float(v1.y, v2.y);
	rv.z = min_float(v1.z, v2.z);
	rv.w = min_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> min(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = min_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float mod(const float v1, const float v2) {
	return mod_float(v1, v2);
}

Vec2<float> mod(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = mod_float(v1.x, v2.x);
	rv.y = mod_float(v1.y, v2.y);

	return rv;
}

Vec3<float> mod(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = mod_float(v1.x, v2.x);
	rv.y = mod_float(v1.y, v2.y);
	rv.z = mod_float(v1.z, v2.z);

	return rv;
}

Vec4<float> mod(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = mod_float(v1.x, v2.x);
	rv.y = mod_float(v1.y, v2.y);
	rv.z = mod_float(v1.z, v2.z);
	rv.w = mod_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> mod(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = mod_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float neq(const float v1, const float v2) {
	return neq_float(v1, v2);
}

Vec2<float> neq(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = neq_float(v1.x, v2.x);
	rv.y = neq_float(v1.y, v2.y);

	return rv;
}

Vec3<float> neq(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = neq_float(v1.x, v2.x);
	rv.y = neq_float(v1.y, v2.y);
	rv.z = neq_float(v1.z, v2.z);

	return rv;
}

Vec4<float> neq(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = neq_float(v1.x, v2.x);
	rv.y = neq_float(v1.y, v2.y);
	rv.z = neq_float(v1.z, v2.z);
	rv.w = neq_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> neq(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = neq_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float neqp(const float v1, const float v2) {
	return neqp_float(v1, v2);
}

Vec2<float> neqp(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = neqp_float(v1.x, v2.x);
	rv.y = neqp_float(v1.y, v2.y);

	return rv;
}

Vec3<float> neqp(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = neqp_float(v1.x, v2.x);
	rv.y = neqp_float(v1.y, v2.y);
	rv.z = neqp_float(v1.z, v2.z);

	return rv;
}

Vec4<float> neqp(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = neqp_float(v1.x, v2.x);
	rv.y = neqp_float(v1.y, v2.y);
	rv.z = neqp_float(v1.z, v2.z);
	rv.w = neqp_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> neqp(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = neqp_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float pow(const float v1, const float v2) {
	return pow_float(v1, v2);
}

Vec2<float> pow(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = pow_float(v1.x, v2.x);
	rv.y = pow_float(v1.y, v2.y);

	return rv;
}

Vec3<float> pow(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = pow_float(v1.x, v2.x);
	rv.y = pow_float(v1.y, v2.y);
	rv.z = pow_float(v1.z, v2.z);

	return rv;
}

Vec4<float> pow(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = pow_float(v1.x, v2.x);
	rv.y = pow_float(v1.y, v2.y);
	rv.z = pow_float(v1.z, v2.z);
	rv.w = pow_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> pow(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = pow_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float lxor(const float v1, const float v2) {
	return lxor_float(v1, v2);
}

Vec2<float> lxor(const Vec2<float> &v1, const Vec2<float> &v2) {
	Vec2<float> rv;
	rv.x = lxor_float(v1.x, v2.x);
	rv.y = lxor_float(v1.y, v2.y);

	return rv;
}

Vec3<float> lxor(const Vec3<float> &v1, const Vec3<float> &v2) {
	Vec3<float> rv;
	rv.x = lxor_float(v1.x, v2.x);
	rv.y = lxor_float(v1.y, v2.y);
	rv.z = lxor_float(v1.z, v2.z);

	return rv;
}

Vec4<float> lxor(const Vec4<float> &v1, const Vec4<float> &v2) {
	Vec4<float> rv;
	rv.x = lxor_float(v1.x, v2.x);
	rv.y = lxor_float(v1.y, v2.y);
	rv.z = lxor_float(v1.z, v2.z);
	rv.w = lxor_float(v1.w, v2.w);

	return rv;
}

template <unsigned N>
VecN<float, N> lxor(const VecN<float, N> &v1, const VecN<float, N> &v2) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = lxor_float(v1.v[i], v2.v[i]);
	}
	return rv;
}

float foldop(const float v1, const float v2, const float v3) {
	return foldop_float(v1, v2, v3);
}

Vec2<float> foldop(
	const Vec2<float> &v1, 
	const Vec2<float> &v2, 
	const Vec2<float> &v3
) {
	Vec2<float> rv;
	rv.x = foldop_float(v1.x, v2.x, v3.x);
	rv.y = foldop_float(v1.y, v2.y, v3.y);

	return rv;
}

Vec3<float> foldop(
	const Vec3<float> &v1, 
	const Vec3<float> &v2, 
	const Vec3<float> &v3
) {
	Vec3<float> rv;
	rv.x = foldop_float(v1.x, v2.x, v3.x);
	rv.y = foldop_float(v1.y, v2.y, v3.y);
	rv.z = foldop_float(v1.z, v2.z, v3.z);

	return rv;
}

Vec4<float> foldop(
	const Vec4<float> &v1, 
	const Vec4<float> &v2, 
	const Vec4<float> &v3
) {
	Vec4<float> rv;
	rv.x = foldop_float(v1.x, v2.x, v3.x);
	rv.y = foldop_float(v1.y, v2.y, v3.y);
	rv.z = foldop_float(v1.z, v2.z, v3.z);
	rv.w = foldop_float(v1.w, v2.w, v3.w);

	return rv;
}

template <unsigned N>
VecN<float, N> foldop(
	const VecN<float, N> &v1, 
	const VecN<float, N> &v2,
	const VecN<float, N> &v3
) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = foldop_float(v1.v[i], v2.v[i], v3.v[i]);
	}
	return rv;
}

float smoothstep(const float v1, const float v2, const float v3) {
	return smoothstep_float(v1, v2, v3);
}

Vec2<float> smoothstep(
	const Vec2<float> &v1, 
	const Vec2<float> &v2, 
	const Vec2<float> &v3
) {
	Vec2<float> rv;
	rv.x = smoothstep_float(v1.x, v2.x, v3.x);
	rv.y = smoothstep_float(v1.y, v2.y, v3.y);

	return rv;
}

Vec3<float> smoothstep(
	const Vec3<float> &v1, 
	const Vec3<float> &v2, 
	const Vec3<float> &v3
) {
	Vec3<float> rv;
	rv.x = smoothstep_float(v1.x, v2.x, v3.x);
	rv.y = smoothstep_float(v1.y, v2.y, v3.y);
	rv.z = smoothstep_float(v1.z, v2.z, v3.z);

	return rv;
}

Vec4<float> smoothstep(
	const Vec4<float> &v1, 
	const Vec4<float> &v2, 
	const Vec4<float> &v3
) {
	Vec4<float> rv;
	rv.x = smoothstep_float(v1.x, v2.x, v3.x);
	rv.y = smoothstep_float(v1.y, v2.y, v3.y);
	rv.z = smoothstep_float(v1.z, v2.z, v3.z);
	rv.w = smoothstep_float(v1.w, v2.w, v3.w);

	return rv;
}

template <unsigned N>
VecN<float, N> smoothstep(
	const VecN<float, N> &v1, 
	const VecN<float, N> &v2,
	const VecN<float, N> &v3
) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = smoothstep_float(v1.v[i], v2.v[i], v3.v[i]);
	}
	return rv;
}

float switchop(const float v1, const float v2, const float v3) {
	return switchop_float(v1, v2, v3);
}

Vec2<float> switchop(
	const Vec2<float> &v1, 
	const Vec2<float> &v2, 
	const Vec2<float> &v3
) {
	Vec2<float> rv;
	rv.x = switchop_float(v1.x, v2.x, v3.x);
	rv.y = switchop_float(v1.y, v2.y, v3.y);

	return rv;
}

Vec3<float> switchop(
	const Vec3<float> &v1, 
	const Vec3<float> &v2, 
	const Vec3<float> &v3
) {
	Vec3<float> rv;
	rv.x = switchop_float(v1.x, v2.x, v3.x);
	rv.y = switchop_float(v1.y, v2.y, v3.y);
	rv.z = switchop_float(v1.z, v2.z, v3.z);

	return rv;
}

Vec4<float> switchop(
	const Vec4<float> &v1, 
	const Vec4<float> &v2, 
	const Vec4<float> &v3
) {
	Vec4<float> rv;
	rv.x = switchop_float(v1.x, v2.x, v3.x);
	rv.y = switchop_float(v1.y, v2.y, v3.y);
	rv.z = switchop_float(v1.z, v2.z, v3.z);
	rv.w = switchop_float(v1.w, v2.w, v3.w);

	return rv;
}

template <unsigned N>
VecN<float, N> switchop(
	const VecN<float, N> &v1, 
	const VecN<float, N> &v2,
	const VecN<float, N> &v3
) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = switchop_float(v1.v[i], v2.v[i], v3.v[i]);
	}
	return rv;
}

float wrapop(const float v1, const float v2, const float v3) {
	return wrapop_float(v1, v2, v3);
}

Vec2<float> wrapop(
	const Vec2<float> &v1, 
	const Vec2<float> &v2, 
	const Vec2<float> &v3
) {
	Vec2<float> rv;
	rv.x = wrapop_float(v1.x, v2.x, v3.x);
	rv.y = wrapop_float(v1.y, v2.y, v3.y);

	return rv;
}

Vec3<float> wrapop(
	const Vec3<float> &v1, 
	const Vec3<float> &v2, 
	const Vec3<float> &v3
) {
	Vec3<float> rv;
	rv.x = wrapop_float(v1.x, v2.x, v3.x);
	rv.y = wrapop_float(v1.y, v2.y, v3.y);
	rv.z = wrapop_float(v1.z, v2.z, v3.z);

	return rv;
}

Vec4<float> wrapop(
	const Vec4<float> &v1, 
	const Vec4<float> &v2, 
	const Vec4<float> &v3
) {
	Vec4<float> rv;
	rv.x = wrapop_float(v1.x, v2.x, v3.x);
	rv.y = wrapop_float(v1.y, v2.y, v3.y);
	rv.z = wrapop_float(v1.z, v2.z, v3.z);
	rv.w = wrapop_float(v1.w, v2.w, v3.w);

	return rv;
}

template <unsigned N>
VecN<float, N> wrapop(
	const VecN<float, N> &v1, 
	const VecN<float, N> &v2,
	const VecN<float, N> &v3
) {
	VecN<float, N> rv;
	for(unsigned int i=0; i < N; i++) {
		rv.v[i] = wrapop_float(v1.v[i], v2.v[i], v3.v[i]);
	}
	return rv;
}



#endif // JIT_CODEGEN_OP_FLOAT_HPP
